# Contributing to JSQMessagesViewController

## Code of Conduct

Please read our [Code of Conduct](https://github.com/jessesquires/JSQMessagesViewController/blob/develop/.github/CONDUCT.md). Intolerance, disrespect, and any of form of negativity will not be tolerated.

## Opening a new issue

1. Read *all* of the [`README`](https://github.com/jessesquires/JSQMessagesViewController/blob/develop/README.md) :speak_no_evil:
* Search [open issues](https://github.com/jessesquires/JSQMessagesViewController/issues) *and* [closed issues](https://github.com/jessesquires/JSQMessagesViewController/issues?q=is%3Aissue+is%3Aclosed) to **avoid opening a duplicate issue!** :see_no_evil:
* If your issue exists, please comment on its thread with your new information :hear_no_evil:
* Otherwise, open a new issue with a good title and description :memo:
* Provide **all** of the following information:
  - Library version(s) :octocat:
  - iOS version(s) :iphone:
  - Devices/Simulators affected :iphone:
  - Expected behavior vs actual behavior
  - Complete steps to reproduce the issue :warning:
  - Link to a project that exhibits the issue, if possible fork the repo and modify the provided demo project :construction:
  - Screenshots/GIFs/Videos showing the issue, if applicable :camera:
  - Full crash log, if applicable :boom:
  - Search for and list any issues that might be related :mag_right:

## Submitting a pull request

1. Link to the issue that the pull request resolves. If there isn't one, create one.
2. Write unit tests that test your changes, if applicable.
3. Update header docs, if needed.
4. Follow existing coding style, and these [style guidelines](https://github.com/jessesquires/HowToContribute#style-guidelines).
5. Resolve any merge conflicts.
6. Squash your commits into a single commit.

## Questions and help

See the [Questions & Help](https://github.com/jessesquires/JSQMessagesViewController/blob/develop/README.md#questions--help), and [Documentation](https://github.com/jessesquires/JSQMessagesViewController/blob/develop/README.md#documentation) sections in the `README`.

## General guidelines

Please also read through these more general [contribution guidelines](https://github.com/jessesquires/HowToContribute).

## Did you read all of this?

You even followed the links? Congratulations! You deserve a high-five. :tada:

![img](http://media.giphy.com/media/LdnaND03GRE9q/giphy.gif)

### New issue checklist

Now show me how awesome you are! :smile: When opening your new issue and filling out the checklist, you'll be asked for confirmation. Confirm that you've read this with these emoji: :muscle::sunglasses::facepunch:

> - [x] I have reviewed the contributing guidelines. Confirmation: :muscle::sunglasses::facepunch:
